﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.51
@EndOfDesignText@
Sub Class_Globals
	Dim noMe As NativeObject=Me
	Dim assets As List, fileNames As List, types As List
	
	Private mHandler As Object
	Private mEventName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (handler As Object, eventName As String)
	mHandler = handler
	mEventName = eventName
End Sub

public Sub GetAssets
	noMe.RunMethod("GetAssets", Null)
End Sub

Public Sub GetVideo(Video_handle As Object, Path As String)
	noMe.RunMethod("getvideo::", Array(Video_handle, Path))
End Sub


Private Sub Assets_ready(lstAssets As Object, lstFileNames As Object, lstTypes As Object)
	Dim no As NativeObject = lstAssets
	Dim no2 As NativeObject = lstFileNames
	Dim no3 As NativeObject = lstTypes

	assets = no
	fileNames = no2
	types = no3
	
	no = Null
	no2 = Null
	no3 = Null
	
	CallSub(mHandler,mEventName & "_Ready")
End Sub


Private Sub Assets_failed
	CallSub(mHandler,mEventName & "_Failed")
End Sub

#If OBJC

#import <AssetsLibrary/AssetsLibrary.h>

-(void)GetAssets
{

	dispatch_group_t loadingGroup = dispatch_group_create();
	NSMutableArray * assets = [[NSMutableArray array] init];
	NSMutableArray * albums = [[NSMutableArray array] init];
	NSMutableArray * filenames = [[NSMutableArray array] init];
	NSMutableArray * types = [[NSMutableArray array] init];

	void (^assetEnumerator)(ALAsset *, NSUInteger, BOOL *) = ^(ALAsset *asset, NSUInteger index, BOOL *stop) {
	    if(index != NSNotFound) {
	       
		    //NSURL * url=[[asset valueForProperty:ALAssetPropertyURLs] valueForKey:[[[asset valueForProperty:ALAssetPropertyURLs] allKeys] objectAtIndex:0]];
		    //NSString* url2=[url absoluteString];
			NSString* originalFileName = [[asset defaultRepresentation] filename];
		   	
			if ([[asset valueForProperty:ALAssetPropertyType] isEqualToString:ALAssetTypePhoto]) {
			   [assets addObject:asset];
		       [filenames addObject:originalFileName];
		       [types addObject:@"ALAssetTypePhoto"];
			} 

			if ([[asset valueForProperty:ALAssetPropertyType] isEqualToString:ALAssetTypeVideo]) {
			   [assets addObject:asset];
		       [filenames addObject:originalFileName];
		       [types addObject:@"ALAssetTypeVideo"];
			} 
		
			dispatch_async(dispatch_get_main_queue(), ^{ });
	    } else {
	        dispatch_group_leave(loadingGroup);
	    }
	};

	void (^assetGroupEnumerator)(ALAssetsGroup *, BOOL *) =  ^(ALAssetsGroup *group, BOOL *stop) {
	    if(group != nil) {
	        [albums addObject: group];
	    } else {
	         NSLog(@"Found %d albums", [albums count]);
	         
			 // album loading is done
	        for (ALAssetsGroup * album in albums) {
	            dispatch_group_enter(loadingGroup);
	            [album enumerateAssetsUsingBlock: assetEnumerator];
	        }
	        dispatch_group_notify(loadingGroup, dispatch_get_main_queue(), ^{
	            NSLog(@"DONE: ALAsset array contains %d elements", [filenames count]);
	 			[self.bi raiseEvent:nil event:@"assets_ready:::" params:@[(assets),(filenames),(types)]];
	        });
	    }
};

//ALAssetsLibrary * library = [[ALAssetsLibrary alloc] init];
ALAssetsLibrary * library=[self defaultAssetsLibrary] ;
[library enumerateGroupsWithTypes: ALAssetsGroupAll
//ALAssetsGroupSavedPhotos | ALAssetsGroupAlbum
                   usingBlock:assetGroupEnumerator
                 failureBlock: ^(NSError *error) {
                     NSLog(@"Failed.");
					 [self.bi raiseEvent:nil event:@"assets_failed" params:@[]];

                 }];
}


/////////////////////////////////////////////////////////////////////////////////////


- (ALAssetsLibrary *)defaultAssetsLibrary {
    static dispatch_once_t pred = 0;
    static ALAssetsLibrary *library = nil;
    dispatch_once(&pred, ^{
        library = [[ALAssetsLibrary alloc] init];
    });
    return library; 
}

/////////////////////////////////////////////////////////////////////////////////////

-(UIImage*)getbitmap :(ALAsset*) photo
{  
    ALAssetRepresentation *defaultRep = [photo defaultRepresentation];
    UIImage *_image = [UIImage imageWithCGImage:[defaultRep fullScreenImage] scale:[defaultRep scale] orientation:0];
	return _image;
}

/////////////////////////////////////////////////////////////////////////////////////

-(void)getvideo :(ALAsset*) video :(NSString*) path
{  
    ALAssetRepresentation *defaultRep = [video defaultRepresentation];
    long long length = [defaultRep size];
	
    NSFileHandle *file = [NSFileHandle fileHandleForWritingAtPath:path];

    if(file == nil) {
        [[NSFileManager defaultManager] createFileAtPath:path contents:nil attributes:nil];
        file = [NSFileHandle fileHandleForWritingAtPath:path];
    }
	
    NSUInteger chunkSize = 100 * 1024;
    uint8_t *buffer = malloc(chunkSize * sizeof(uint8_t));
    NSUInteger offset = 0;

    do {
        NSUInteger bytesCopied = [defaultRep getBytes:buffer fromOffset:offset length:chunkSize error:nil];
        offset += bytesCopied;
        NSData *data = [[NSData alloc] initWithBytes:buffer length:bytesCopied];
        [file writeData:data];
        } while (offset < length);

    [file closeFile];
    free(buffer);
    buffer = NULL;
}

	#End If
